package com.ruoyi.system.mapper;

import java.time.LocalDate;
import java.util.List;
import com.ruoyi.system.domain.SysOrder;
import com.ruoyi.system.domain.dto.OrderDetailDto;
import com.ruoyi.system.domain.dto.OrderListDto;
import com.ruoyi.system.domain.dto.SysOrderPayBackDto;
import org.apache.ibatis.annotations.Param;

/**
 * 订单信息Mapper接口
 * 
 * @author haotian
 * @date 2024-11-21
 */
public interface SysOrderMapper 
{
    /**
     * 查询订单信息
     * 
     * @param orderId 订单信息主键
     * @return 订单信息
     */
    public SysOrder selectSysOrderByOrderId(Long orderId);

    /**
     * 查询订单信息列表
     * 
     * @param sysOrder 订单信息
     * @return 订单信息集合
     */
    public List<SysOrder> selectSysOrderList(SysOrder sysOrder);

    /**
     * 新增订单信息
     * 
     * @param sysOrder 订单信息
     * @return 结果
     */
    public int insertSysOrder(SysOrder sysOrder);

    /**
     * 修改订单信息
     * 
     * @param sysOrder 订单信息
     * @return 结果
     */
    public int updateSysOrder(SysOrder sysOrder);

    /**
     * 删除订单信息
     * 
     * @param orderId 订单信息主键
     * @return 结果
     */
    public int deleteSysOrderByOrderId(Long orderId);

    /**
     * 批量删除订单信息
     * 
     * @param orderIds 需要删除的数据主键集合
     * @return 结果
     */
    public int deleteSysOrderByOrderIds(Long[] orderIds);

    /*
    * 检查订单时间是否合法*/
    public int isTimeLegal(@Param("startTime")LocalDate startTime, @Param("endTime") LocalDate endTime, @Param("sourceId") Long sourceId);

    public List<OrderListDto> getOrderListDto(SysOrder sysOrder);

    public OrderDetailDto getOrderDetailDto(@Param("orderId") Long orderId, @Param("id") Long id);

    /*
     * 系统每天--根据日期和订单状态 计数收入/退款
     * */
    public Long getMoneybyDateAndStatus(@Param("date") LocalDate date);

    /*
     * 系统每天--根据日期计数退款
     * */
    public Long getRefund(@Param("date") LocalDate date);

    /**
     *
     * 支付回调后根据orderId返回订单详情
     * */
    public SysOrderPayBackDto getSysOrderPayBackDto(Long orderId);
}
